diff --git a/toolkit/components/printing/content/printUtils.js b/toolkit/components/printing/content/printUtils.js
--- a/toolkit/components/printing/content/printUtils.js
+++ b/toolkit/components/printing/content/printUtils.js
@@ -132,29 +132,38 @@ var PrintUtils = {
         var webNav = getWebNavigation();
         ppParams.value.docTitle = webNav.document.title;
         ppParams.value.docURL   = webNav.currentURI.spec;
       }
 
       // this tells us whether we should continue on with PP or 
       // wait for the callback via the observer
       if (!notifyOnOpen.value.valueOf() || this._webProgressPP.value == null)
-        this.enterPrintPreview();
+        this.enterPrintPreview(aWindow);
     } catch (e) {
-      this.enterPrintPreview();
+      this.enterPrintPreview(aWindow);
     }
   },
 
   getWebBrowserPrint: function (aWindow)
   {
     var contentWindow = aWindow || window.content;
     return contentWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                         .getInterface(Components.interfaces.nsIWebBrowserPrint);
   },
 
+  getPrintPreview: function() {
+    if (this._printPreviewTab) {
+      var ppWindow =
+        getPPBrowser().getBrowserForTab(this._printPreviewTab).contentWindow;
+      return this.getWebBrowserPrint(ppWindow);
+    }
+    return null;
+  },
+
   ////////////////////////////////////////
   // "private" methods. Don't use them. //
   ////////////////////////////////////////
 
   setPrinterDefaultsForSelectedPrinter: function (aPSSVC, aPrintSettings)
   {
     if (!aPrintSettings.printerName)
       aPrintSettings.printerName = aPSSVC.defaultPrinterName;
@@ -209,38 +218,67 @@ var PrintUtils = {
       if (iid.equals(Components.interfaces.nsIObserver) ||
           iid.equals(Components.interfaces.nsISupportsWeakReference) ||
           iid.equals(Components.interfaces.nsISupports))
         return this;   
       throw Components.results.NS_NOINTERFACE;
     }
   },
 
+  _originalTab: null,
+  _printPreviewTab: null,
+
   enterPrintPreview: function (aWindow)
   {
     gFocusedElement = document.commandDispatcher.focusedElement;
 
-    var webBrowserPrint = this.getWebBrowserPrint(aWindow);
-    var printSettings   = this.getPrintSettings();
+    var webBrowserPrint;
+    var printSettings  = this.getPrintSettings();
+    var tabbrowser = getPPBrowser();
+    var targetWindow = null;
+    var contentWindow = null;
+    if (tabbrowser) {
+      if (this._printPreviewTab) {
+        targetWindow =
+          tabbrowser.getBrowserForTab(this._printPreviewTab).contentWindow;
+        contentWindow = targetWindow;
+      } else {
+        this._originalTab = tabbrowser.mCurrentTab;
+        contentWindow = aWindow || window.content
+        this._printPreviewTab = tabbrowser.loadOneTab("about:blank", null, null,
+                                                      null, true, false);
+        var targetBrowser = tabbrowser.getBrowserForTab(this._printPreviewTab);
+        targetBrowser.stop();
+        targetWindow = targetBrowser.contentWindow;
+      }
+    }
+
     try {
-      webBrowserPrint.printPreview(printSettings, null, this._webProgressPP.value);
+      webBrowserPrint = this.getWebBrowserPrint(targetWindow);
+      webBrowserPrint.printPreview(printSettings, contentWindow,
+                                  this._webProgressPP.value);
     } catch (e) {
+      this._printPreviewTab = null;
+      this._originalTab = null;
       // Pressing cancel is expressed as an NS_ERROR_ABORT return value,
       // causing an exception to be thrown which we catch here.
       // Unfortunately this will also consume helpful failures, so add a
       // dump(e); // if you need to debug
       return;
     }
 
     var printPreviewTB = document.getElementById("print-preview-toolbar");
     if (printPreviewTB) {
       printPreviewTB.updateToolbar();
       var browser = getPPBrowser();
       if (browser)
         browser.collapsed = false;
+
+      tabbrowser.getBrowserForTab(this._printPreviewTab).contentWindow.focus();
+      tabbrowser.selectedTab = this._printPreviewTab;
       return;
     }
 
     // show the toolbar after we go into print preview mode so
     // that we can initialize the toolbar with total num pages
     var XUL_NS =
       "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
     printPreviewTB = document.createElementNS(XUL_NS, "toolbar");
@@ -254,19 +292,19 @@ var PrintUtils = {
     if (document.documentElement.hasAttribute("onclose"))
       this._closeHandlerPP = document.documentElement.getAttribute("onclose");
     else
       this._closeHandlerPP = null;
     document.documentElement.setAttribute("onclose", "PrintUtils.exitPrintPreview(); return false;");
 
     // disable chrome shortcuts...
     window.addEventListener("keypress", this.onKeyPressPP, true);
- 
-    var contentWindow = aWindow || window.content;
-    contentWindow.focus();
+
+    tabbrowser.getBrowserForTab(this._printPreviewTab).contentWindow.focus();
+    tabbrowser.selectedTab = this._printPreviewTab;
 
     // on Enter PP Call back
     if (this._onEnterPP) {
       this._onEnterPP();
       this._onEnterPP = null;
     }
   },
 
@@ -276,16 +314,24 @@ var PrintUtils = {
 
     // restore the old close handler
     document.documentElement.setAttribute("onclose", this._closeHandlerPP);
     this._closeHandlerPP = null;
 
     var webBrowserPrint = this.getWebBrowserPrint(aWindow);
     webBrowserPrint.exitPrintPreview(); 
 
+    var tabbrowser = getPPBrowser();
+    if (tabbrowser) {
+      tabbrowser.removeTab(this._printPreviewTab);
+      tabbrowser.selectedTab = this._originalTab;
+      this._originalTab = null;
+      this._printPreviewTab = null;
+    }
+
     // remove the print preview toolbar
     var printPreviewTB = document.getElementById("print-preview-toolbar");
     getNavToolbox().parentNode.removeChild(printPreviewTB);
 
     var fm = Components.classes["@mozilla.org/focus-manager;1"]
                        .getService(Components.interfaces.nsIFocusManager);
     if (gFocusedElement)
       fm.setFocus(gFocusedElement, fm.FLAG_NOSCROLL);
